from ngsolve import *
import netgen.csg as csg

H = 0.5

left1  = csg.Plane (csg.Pnt(0,0,0), csg.Vec(-1,0,0) ).bc("left")
right1 = csg.Plane (csg.Pnt(1,1,1), csg.Vec( 1,0,0) ).bc("right")
front1 = csg.Plane (csg.Pnt(0,0,0), csg.Vec(0,-1,0) ).bc("front")
back1  = csg.Plane (csg.Pnt(1,1,1), csg.Vec(0, 1,0) ).bc("back")
bot1   = csg.Plane (csg.Pnt(0,0,0), csg.Vec(0,0,-1) ).bc("bot")
top1   = csg.Plane (csg.Pnt(1,1,1), csg.Vec(0,0, 1) ).bc("top")
cube1 = (left1 * right1 * front1 * back1 * bot1 * top1).maxh(0.2)

left2  = csg.Plane (csg.Pnt(1-H,1-H,0), csg.Vec(-1,0,0) ).bc("innerleft")
right2 = csg.Plane (csg.Pnt(1+1,1+H,1), csg.Vec( 1,0,0) ).bc("innerright")
front2 = csg.Plane (csg.Pnt(1-H,1-H,0), csg.Vec(0,-1,0) ).bc("innerfront")
back2  = csg.Plane (csg.Pnt(1+H,1+H,1), csg.Vec(0, 1,0) ).bc("innerback")
bot2   = csg.Plane (csg.Pnt(1-H,1-H,0), csg.Vec(0,0,-1) ).bc("innerbot")
top2   = csg.Plane (csg.Pnt(1+H,1+H,1), csg.Vec(0,0, 1) ).bc("innertop")
cube2 = (left2 * right2 * front2 * back2 * bot2 * top2).maxh(0.2)

cube_out = (cube1 - cube2).maxh(0.2)
cube_inn = (cube1*cube2).maxh(0.2)
geo = csg.CSGeometry()
geo.AddPoint( csg.Pnt(1,1,1),1 )
geo.Add (cube_out)

#Here!
geo.Add (cube_inn, bcmod=[(top2,'innertop')])
#geo.Add (cube_inn)

ngmesh = geo.GenerateMesh(maxh=0.2)
mesh = Mesh(ngmesh)
Draw(mesh)

print(mesh.GetBoundaries())
Draw(CoefficientFunction( [1 if mat =="top" else 0 for mat in mesh.GetBoundaries()]), mesh, "test")
